ad_library {

    APM callbacks for the todo-portlet package

}


namespace eval todo_portlet::apm {}

ad_proc todo_portlet::apm::after_install {
} {
    Register the implementation of the portal_datasource SC
} {

    todo_portlet::apm::register_impl
    
}

ad_proc todo_portlet::apm::after_upgrade { 

    -from_version_name:required
    -to_version_name:required

} {

    Upgrade logic for the todo-portlet package

} {

    apm_upgrade_logic \
        -from_version_name $from_version_name \
        -to_version_name $to_version_name \
        -spec {  
            0.1d1 0.1d2 {

                todo_portlet::apm::register_impl

            }
        }
    
}

ad_proc -private todo_portlet::apm::register_impl {
} {
    Register the portal_datasource implementation for todo-portlet
} {

    portal::datasource::new_from_spec -spec [subst {
        name "[todo_portlet::get_my_name]"
        description "[todo_portlet::get_pretty_name]"
        owner "todo-portlet"
        params { 
            shadeable_p:config_required,configured t
            shaded_p:config_required,configured f
            hideable_p:config_required,configured t
            user_editable_p:config_required,configured f
            link_hideable_p:config_required,configured t
            package_id:config_required {}
        }
        aliases  { 
            AddSelfToPage todo_portlet::add_self_to_page
            Edit todo_portlet::edit
            GetMyName todo_portlet::get_my_name
            GetPrettyName todo_portlet::get_pretty_name
            Link todo_portlet::link
            RemoveSelfFromPage todo_portlet::remove_self_from_page
            Show todo_portlet::show
        }
    }]

}