# /packages/todo/lib/todo-list.tcl


# Permissions
set can_create_p [permission::permission_p -no_login \
                      -party_id $user_id \
                      -object_id $package_id \
                      -privilege "create"]

set extra_url [ns_queryget page_num]

# Actions list
set actions_list [list]

if { $can_create_p } {
    set base_url "[site_node::get_url_from_object_id -object_id $package_id]todo-ae"

    lappend actions_list [_ todo.Add_item] [export_vars -url -base $base_url {{new_p 1}}] [_ todo.Add_a_new_item]
}

# List declaration
template::list::create -name todo_list \
    -actions $actions_list \
    -bulk_actions [list [_ todo.Delete_items] "todo-delete" [_ todo.Delete_checked_items]] \
    -bulk_action_export_vars { return_url } \
    -multirow todo_list \
    -key item_id \
    -elements {
        title {
            label "[_ todo.Title]"
            link_url_col item_url
            link_html {title "#todo.View_Edit_an_item#"}
            orderby title
        }
        due_date_pretty {
            label "[_ todo.Due_Date]"
            orderby due_date
        }
        status_text {
            label "[_ todo.Status]"
            orderby status
        }
    } \
    -orderby_name orderby

db_multirow -extend { item_url status_text due_date_pretty } todo_list select_items {} {

    if { [permission::permission_p -no_login \
              -party_id $owner_id \
              -object_id $item_id \
              -privilege "write"] } {

        set item_url [export_vars -url -base "todo-ae" {item_id}]

    }

    set due_date_pretty [lc_time_fmt $due_date %q]
    set status_text [todo::get_status_text $status]

}
