ad_page_contract {
    Form to add or edit a todo item
} {
    item_id:optional
    {new_p 0}
}

# needed to add/edit an item
set user_id [ad_conn user_id]
set package_id [ad_conn package_id]

# Permissions
if { $new_p } {

    set page_title [_ todo.Add_a_new_item]

    permission::require_permission \
        -party_id $user_id \
        -object_id $package_id \
        -privilege "create"

} else {

    set page_title [_ todo.Edit_an_item]

    permission::require_permission \
        -party_id $user_id \
        -object_id $item_id \
        -privilege "write"

}

set context [list $page_title]

ad_form -name todo_item_form -export { user_id new_p } -form {

    {item_id:key
    }
    {title:text 
        {label "[_ todo.Title]"}
        {help_text "Debería estar internacionalizado"}
    }
    {description:text(textarea),nospell
        {label "[_ todo.Description]"}
        {html {rows "10" cols "60"}}
    }
    {due_date:date(date) 
        {label "[_ todo.Due_Date]"}  
    }
    {status:text(select) 
        {label "[_ todo.Status]"}
        {options {
            {"[_ todo.Pending]" "p"}
            {"[_ todo.Complete]" "c"}
            {"[_ todo.Canceled]" "x" }} 
        }
    }

} -new_data {

    package_instantiate_object \
        -var_list [list \
                       [list item_id $item_id] \
                       [list title $title] \
                       [list description $description] \
                       [list status $status] \
                       [list due_date $due_date] \
                       [list owner_id $user_id] \
                       [list package_id $package_id] \
                       [list context_id $package_id] \
                      ] \
        "todo_item"

    permission::grant -party_id $user_id \
        -object_id $item_id \
        -privilege "write"

} -select_query_name {select_item} -edit_data {

    db_exec_plsql update_item {}

} -after_submit {

    ad_returnredirect "index"
    ad_script_abort

}
